#!/bin/bash
#source utils.sh

function get_cpuinfo() {
    cpu=`dmidecode -s processor-version`
    set_array "${cpu}"
}

function get_meminfo() {
    #mem=`dmidecode -t memory | grep -E " MB"`
    mem=`dmidecode -t memory |grep -E "No Module Installed| MB|Configured Memory Speed" | xargs -n 8`
	mem=`trim_string "${mem}"`
    set_array "${mem}"
}

function get_biosinfo() {
    bios=`dmidecode -s bios-version`
    set_array "${bios}"
}

function get_bios_net() {
    bios_net=`dmidecode -t connector | grep -P1 "Network" | awk '{printf $4}'`
    set_array "${bios_net}"
}

function get_kernel_version() {
    kernel_version=`uname -r`
    set_array "${kernel_version}"
}

function get_pcie_net_card() {
    pcie_net_card=`lspci | grep -i eth`
    set_array "${pcie_net_card}"
}

function get_pcie_net_driver() {
    pcie_num=`lspci | grep -i eth | awk '{print $1}' | xargs`
    for dev in ${pcie_num}
    do
        info=`lspci -nnks ${dev}`
        info2=`lspci -vvs ${dev} | grep -E "LnkSta:" | awk '{print $3 $5}'`
        info3=`lspci -vs ${dev} | grep -E "IRQ" | awk '{print $8 $9}'`
        set_array "${info}[${info2}][${info3}]"
    done
}

function get_pcie_bridge() {
    pcie_bridge=`lspci -nn | grep "bridge"`
    set_array "${pcie_bridge}"
}

function get_numa_info() {
    numa_info=`numactl -s`
    set_array "${numa_info}"
}


#get_dmidecode
#get_cpuinfo
#get_meminfo
#get_biosinfo
#get_bios_net
#get_kernel_version
#get_pcie_net_card
#get_pcie_net_driver
#get_pcie_bridge
#get_numa_info

#show_array
