#!/bin/bash
#source utils.sh

function get_all_ethname() {
    eths=`cat /proc/net/dev | grep -E "*:" | awk '{print $1}' | xargs | sed 's/:/ /g'`
    set_array "${eths}"
    ETHS="${eths}"
}

function get_all_eth_info() {
    info=`ip a`
    set_array "${info}"
}

function get_eth_info() {
    info=`ip -o link show $1 | awk '{print $2,$9}'`
    info2=`ethtool $1 | grep "Speed"`
    info2=`trim_string "${info2}"`
    ei=`echo $1 | grep -wE "lo|sit[0-9]"`
    if [ "${ei}" ];then
        info3=""
    else
        info3=`ethtool -i $1 | grep -A2 "driver" | xargs`
    fi
    info4=`cat /proc/interrupts | grep "$1" | awk '{print $1}' | xargs | sed 's/://g'`
    info5=`get_eth_bandwith $1`
    eth_info="${info} [${info2}] [${info3}] [irq:${info4}] ${info5}"
    set_array "${eth_info}"
}

function get_all_eth_info2() {
    eths=`cat /proc/net/dev | grep -E "*:" | awk '{print $1}' | xargs | sed 's/:/ /g'`
    for eth in ${eths}
    do
        get_eth_info ${eth}
    done
}

function get_ethirq_oncpu() {
    eths=`cat /proc/net/dev | grep -E "*:" | awk '{print $1}' | grep -vE "lo|sit" | xargs | sed 's/:/ /g'`
    for eth in ${eths}
    do
        irqs=`cat /proc/interrupts | grep "${eth}" | awk '{print $1}' | xargs | sed 's/://g'`
        for irq in ${irqs}
        do
            cpus=`cat /proc/irq/${irq}/smp_affinity_list`
            set_array "${irq}:${cpus}"
        done
    done
}

function get_eth_bandwith() {
    eth=$1
    if [ -z "${eth}" ];then
        exit
    fi
	RXcur=$(cat /proc/net/dev | grep ${eth}: | tr : " " | awk '{print $2}')
	TXcur=$(cat /proc/net/dev | grep ${eth}: | tr : " " | awk '{print $10}')
    [ -e ${SHELLDIR}/${eth}_rx ] || touch ${SHELLDIR}/${eth}_rx
    [ -e ${SHELLDIR}/${eth}_tx ] || touch ${SHELLDIR}/${eth}_tx
    RXpre=`cat ${SHELLDIR}/${eth}_rx`
    TXpre=`cat ${SHELLDIR}/${eth}_tx`
    echo ${RXcur} > ${SHELLDIR}/${eth}_rx
    echo ${TXcur} > ${SHELLDIR}/${eth}_tx

	RX=$((RXcur-RXpre))
    TX=$((TXcur-TXpre))

    if [[ ${RX} -lt 1024 ]];then
	    RX="${RX}B/s"
    elif [[ ${RX} -gt 1048576 ]];then
	    RX=$(echo ${RX} | awk '{print $1/1048576 "MB/s"}')
    else
	    RX=$(echo ${RX} | awk '{print $1/1024 "KB/s"}')
    fi

	if [[ ${TX} -lt 1024 ]];then
    	TX="${TX}B/s"
    elif [[ $TX -gt 1048576 ]];then
	    TX=$(echo ${TX} | awk '{print $1/1048576 "MB/s"}')
    else
	    TX=$(echo ${TX} | awk '{print $1/1024 "KB/s"}')
    fi

	echo -e "$eth[RX:${RX}|TX:${TX}]"
}

function get_eths_bandwith() {
    eths=`cat /proc/net/dev | grep -E "*:" | awk '{print $1}' | xargs | sed 's/:/ /g'`
    for eth in ${eths}
    do
        get_eth_bandwith ${eth}
    done
}

#get_all_eth_info2
#get_ethirq_oncpu
#get_loop_bandwith &
#show_array
