#!/bin/bash

function get_netstati() {
    netstati=`netstat -i|column -t`
    set_array "${netstati}"
}

function get_netstati_errors2() {
    netstati_error1=`netstat -i | awk 'NR >=2 {rerr+=$5;rdrp+=$6;rovr+=$7;terr+=$9;tdrp+=$10;tovr+=$11} END {print rerr+rdrp+rovr,terr+tdrp+tovr}' | column -t`
    sleep 1
    netstati_error2=`netstat -i | awk 'NR >=2 {rerr+=$5;rdrp+=$6;rovr+=$7;terr+=$9;tdrp+=$10;tovr+=$11} END {print rerr+rdrp+rovr,terr+tdrp+tovr}' | column -t`
    netstati_error="${netstati_error1} ${netstati_error2}"
    r_err=`echo ${netstati_error} | awk '{print $3-$1}'`
    t_err=`echo ${netstati_error} | awk '{print $4-$2}'`
    if [ "${r_err}" -gt "0" ];then
        r_err="链路层接收丢包 ${r_err}"
        set_array "${r_err}"
    fi
    if [ "${t_err}" -gt "0" ];then
        t_err="链路层发送丢包 ${t_err}"
        set_array "${t_err}"
    fi
}

function get_netstati_errors() {
    netstati_error=`netstat -i | awk 'NR >=2 {rerr+=$5;rdrp+=$6;rovr+=$7;terr+=$9;tdrp+=$10;tovr+=$11} END {print rerr+rdrp+rovr,terr+tdrp+tovr}' | column -t`
    r_err=`echo ${netstati_error} | awk '{print $1}'`
    t_err=`echo ${netstati_error} | awk '{print $2}'`
    [ -e ${SHELLDIR}/netstati_error ] || touch ${SHELLDIR}/netstati_error
    l_netstati_error=`cat ${SHELLDIR}/netstati_error`
    echo ${netstati_error} > ${SHELLDIR}/netstati_error
    r_sum=`echo ${l_netstati_error} ${r_err} | awk '{print $3-$1}'`
    t_sum=`echo ${l_netstati_error} ${t_err} | awk '{print $3-$2}'`
    r_err="链路层接收丢包 ${r_err}(+${r_sum})"
    t_err="链路层发送丢包 ${t_err}(+${t_sum})"
    set_array "${r_err} ${t_err}"
}

function get_nf_insert_failed() {
    nf_insert_failed=`cat /proc/net/stat/nf_conntrack | awk 'NR>=2 {insert_failed+=strtonum("0x" $10)} END {print insert_failed}'`
    [ -e ${SHELLDIR}/nf_insert_failed ] || touch ${SHELLDIR}/nf_insert_failed
    l_nf_insert_failed=`cat ${SHELLDIR}/nf_insert_failed`
    echo ${nf_insert_failed} > ${SHELLDIR}/nf_insert_failed
    if_sum=`echo ${nf_insert_failed} ${l_nf_insert_failed} | awk '{print $1-$2}'`
    set_array "NF表插入丢包 ${nf_insert_failed}(+${if_sum})"
}

function get_snmp() {
    snmp=`cat /proc/net/snmp | column -t`
    set_array "${snmp}"
}

function get_iperror_snmp() {
    iperror=`cat /proc/net/snmp | grep "Ip:" | awk -F " " '{print $1,$5,$6,$8,$13,$14,$17,$19,$21}'  | column -t`
    set_array "${iperror}"
}

function get_ipreasm_fails() {
    reasmfails=`cat /proc/net/snmp | grep "Ip:" | awk -F " " '{print $19}'  | column -t | awk 'FNR==2'`
    [ -e ${SHELLDIR}/reasmfails ] || touch ${SHELLDIR}/reasmfails
    l_reasmfails=`cat ${SHELLDIR}/reasmfails`
    echo ${reasmfails} > ${SHELLDIR}/reasmfails
    set_array "IP重组失败 ${reasmfails}(+$((reasmfails-l_reasmfails)))"
}

function get_udprecvbuf_errors() {
    recvbuferrors=`cat /proc/net/snmp | column -t | grep "Udp:" | awk -F " " '{print $6}'  | column -t | awk 'FNR==2'`
    [ -e ${SHELLDIR}/recvbuferrors ] || touch ${SHELLDIR}/recvbuferrors
    l_recvbuferrors=`cat ${SHELLDIR}/recvbuferrors`
    echo ${recvbuferrors} > ${SHELLDIR}/recvbuferrors
    set_array "UDP接收缓冲区错误 ${recvbuferrors}(+$((recvbuferrors-l_recvbuferrors)))"
}

function get_udpsndbuf_errors() {
    sndbuferrors=`cat /proc/net/snmp | column -t | grep "Udp:" | awk -F " " '{print $7}'  | column -t | awk 'FNR==2'`
    [ -e ${SHELLDIR}/sndbuferrors ] || touch ${SHELLDIR}/sndbuferrors
    l_sndbuferrors=`cat ${SHELLDIR}/sndbuferrors`
    echo ${sndbuferrors} > ${SHELLDIR}/sndbuferrors
    set_array "UDP发送缓冲区错误 ${sndbuferrors}(+$((sndbuferrors-l_sndbuferrors)))"
}

function get_rmem_max() {
    rmemmax=`sysctl -n net.core.rmem_max`
    set_array "${rmemmax}"
}

function get_rmem_default() {
    rmemdefault=`sysctl -n net.core.rmem_default`
    set_array "${rmemdefault}"
}

function get_wmem_max() {
    wmemmax=`sysctl -n net.core.wmem_max`
    set_array "${wmemmax}"
}

function get_wmem_default() {
    wmemdefault=`sysctl -n net.core.wmem_default`
    set_array "${wmemdefault}"
}

function get_rmem_wmem() {
    rmemmax=`sysctl -n net.core.rmem_max`
    rmemdefault=`sysctl -n net.core.rmem_default`
    wmemmax=`sysctl -n net.core.wmem_max`
    wmemdefault=`sysctl -n net.core.wmem_default`
    set_array "rmem_max ${rmemmax} rmem_default ${rmemdefault} wmemmax ${wmemmax} wmemdefault ${wmemdefault}"
}

function get_default_rp_filter() {
    default_rp_filter=`sysctl -n net.ipv4.conf.default.rp_filter`
    set_array "${default_rp_filter}"
}

function get_all_rp_filter() {
    all_rp_filter=`sysctl -n net.ipv4.conf.all.rp_filter`
    set_array "${all_rp_filter}"
}

